/*
 * xrick/src/system.c
 *
 * This source code file is part of the xrick distribution, and as such is
 * copyrighted. Please read the README file in the root directory of the
 * distribution for information about copyrights, trademarks, license,
 * disclaimers, etc.
 */

#include <gpstdio.h>
#include <gpstdlib.h>

#include "system.h"

/*
 * Panic
 */
void sys_panic(char *err, ...)
{
	GpRectFill(NULL, &gpDraw[vid_page], 0, 0, 320, 240, 0x01);	
	while(1){}
}


/*
 * Print a message
 */
void sys_printf(char *msg, ...)
{
}


/*
 * Return number of microseconds elapsed since first call
 */
U32 sys_gettime(void)
{
  static U32 ticks_base = 0;
  U32 ticks;

  ticks = GpTickCountGet();

  if (!ticks_base)
    ticks_base = ticks;

  return ticks - ticks_base;

}

/*
 * Sleep a number of microseconds
 */
void
sys_sleep(int s)
{
	unsigned int t1;

	t1 = GpTickCountGet();
	while((GpTickCountGet() - t1) < s){
	}
}

/*
 * Initialize system
 */
void
sys_init(void)
{
  sysarg_init();
  sysvid_init();

#ifdef ENABLE_SOUND
  if (sysarg_args_nosound == 0)
    syssnd_init();
#endif
}

/*
 * Shutdown system
 */
void
sys_shutdown(void)
{
#ifdef ENABLE_SOUND
  syssnd_shutdown();
#endif
  sysvid_shutdown();
}

/* eof */
